import numpy as np
import pandas as pd
import regression as reg

nsample = 300 

train_data = pd.read_csv("train.csv")
test_data = pd.read_csv("test.csv")

train_data = train_data.drop(['red or white'], axis=1) #remove 'red or white' information.
test_data = test_data.drop(['red or white'], axis=1) 
#train_data = train_data.replace({'R':1,'W':0}) # replace 'R' with 1, 'W' with 0, repectively.
#test_data = test_data.replace({'R':1,'W':0}) 

X = np.matrix(train_data.drop(['quality'], axis=1)) 
y = np.matrix(train_data['quality'])

XTrain = X[:nsample,:] #use the first 300 samples for training
yTrain = y[:,:nsample]
XVal = X[nsample:,:] #use the rests for validation
yVal = y[:,nsample:]

w = reg.standRegres(XTrain,yTrain) #linear regression

yHatTrain = np.dot(XTrain,w)
yHatVal = np.dot(XVal,w)

print "Training error ", np.mean(np.abs(yTrain - yHatTrain.T))
print "Validation error ", np.mean(np.abs(yVal - yHatVal.T))

yHatTest = np.dot(np.matrix(test_data),w)
np.savetxt('result.txt', yHatTest)
